Index: uspace/lib/device/include/ipc/devman.h
===================================================================
--- uspace/lib/device/include/ipc/devman.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/devman.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -31,6 +31,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_DEVMAN_H
-#define LIBDEVICE_IPC_DEVMAN_H
+#ifndef _LIBC_IPC_DEVMAN_H_
+#define _LIBC_IPC_DEVMAN_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/irc.h
===================================================================
--- uspace/lib/device/include/ipc/irc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/irc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_IRC_H
-#define LIBDEVICE_IPC_IRC_H
+#ifndef _LIBC_IPC_IRC_H_
+#define _LIBC_IPC_IRC_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/pci.h
===================================================================
--- uspace/lib/device/include/ipc/pci.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/pci.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_PCI_H
-#define LIBDEVICE_IPC_PCI_H
+#ifndef _LIBC_IPC_PCI_H_
+#define _LIBC_IPC_PCI_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/serial_ctl.h
===================================================================
--- uspace/lib/device/include/ipc/serial_ctl.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/serial_ctl.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,6 +27,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_SERIAL_CTL_H
-#define LIBDEVICE_IPC_SERIAL_CTL_H
+#ifndef _LIBC_IPC_SERIAL_CTL_H_
+#define _LIBC_IPC_SERIAL_CTL_H_
 
 #include <ipc/chardev.h>
Index: uspace/lib/device/include/ipc/vbd.h
===================================================================
--- uspace/lib/device/include/ipc/vbd.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/vbd.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
 
-#ifndef LIBDEVICE_IPC_VBD_H
-#define LIBDEVICE_IPC_VBD_H
+#ifndef _LIBC_IPC_VBD_H_
+#define _LIBC_IPC_VBD_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/vol.h
===================================================================
--- uspace/lib/device/include/ipc/vol.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/vol.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
 
-#ifndef LIBDEVICE_IPC_VOL_H
-#define LIBDEVICE_IPC_VOL_H
+#ifndef _LIBC_IPC_VOL_H_
+#define _LIBC_IPC_VOL_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/irc.h
===================================================================
--- uspace/lib/device/include/irc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/irc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IRC_H
-#define LIBDEVICE_IRC_H
+#ifndef _LIBC_IRC_H_
+#define _LIBC_IRC_H_
 
 extern errno_t irc_enable_interrupt(int);
Index: uspace/lib/device/include/nic/eth_phys.h
===================================================================
--- uspace/lib/device/include/nic/eth_phys.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/nic/eth_phys.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -28,6 +28,6 @@
  */
 
-#ifndef LIBDEVICE_NIC_ETH_PHYS_H
-#define LIBDEVICE_NIC_ETH_PHYS_H
+#ifndef _LIBC_NIC_ETH_PHYS_H_
+#define _LIBC_NIC_ETH_PHYS_H_
 
 #include <stdint.h>
Index: uspace/lib/device/include/nic/nic.h
===================================================================
--- uspace/lib/device/include/nic/nic.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/nic/nic.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -36,6 +36,6 @@
  */
 
-#ifndef LIBDEVICE_NIC_H
-#define LIBDEVICE_NIC_H
+#ifndef _LIBC_NIC_H_
+#define _LIBC_NIC_H_
 
 #include <nic/eth_phys.h>
@@ -269,5 +269,5 @@
 	/** The mask of all modes which the device can advertise
 	 *
-	 *  see ETH_AUTONEG_ macros in nic/eth_phys.h of libdevice
+	 *  see ETH_AUTONEG_ macros in nic/eth_phys.h of libc
 	 */
 	uint32_t autoneg_support;
Index: uspace/lib/device/include/pci.h
===================================================================
--- uspace/lib/device/include/pci.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/pci.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_PCI_H
-#define LIBDEVICE_PCI_H
+#ifndef _LIBC_PCI_H_
+#define _LIBC_PCI_H_
 
 #include <errno.h>
Index: uspace/lib/device/include/types/io/chardev.h
===================================================================
--- uspace/lib/device/include/types/io/chardev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/types/io/chardev.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -26,10 +26,10 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
 
-#ifndef LIBDEVICE_TYPES_IO_CHARDEV_H
-#define LIBDEVICE_TYPES_IO_CHARDEV_H
+#ifndef _LIBC_TYPES_IO_CHARDEV_H_
+#define _LIBC_TYPES_IO_CHARDEV_H_
 
 /** Chardev read/write operation flags */
Index: uspace/lib/device/include/types/label.h
===================================================================
--- uspace/lib/device/include/types/label.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/types/label.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_TYPES_LABEL_H
-#define LIBDEVICE_TYPES_LABEL_H
+#ifndef _LIBC_TYPES_LABEL_H_
+#define _LIBC_TYPES_LABEL_H_
 
 #include <types/uuid.h>
Index: uspace/lib/device/include/types/pci.h
===================================================================
--- uspace/lib/device/include/types/pci.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/types/pci.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_TYPES_PCI_H
-#define LIBDEVICE_TYPES_PCI_H
+#ifndef _LIBC_TYPES_PCI_H_
+#define _LIBC_TYPES_PCI_H_
 
 #include <async.h>
Index: uspace/lib/device/include/types/vol.h
===================================================================
--- uspace/lib/device/include/types/vol.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/types/vol.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_TYPES_VOL_H
-#define LIBDEVICE_TYPES_VOL_H
+#ifndef _LIBC_TYPES_VOL_H_
+#define _LIBC_TYPES_VOL_H_
 
 #include <async.h>
Index: uspace/lib/device/include/vbd.h
===================================================================
--- uspace/lib/device/include/vbd.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/vbd.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_VBD_H
-#define LIBDEVICE_VBD_H
+#ifndef _LIBC_VBD_H_
+#define _LIBC_VBD_H_
 
 #include <async.h>
Index: uspace/lib/device/include/vol.h
===================================================================
--- uspace/lib/device/include/vol.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/vol.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_VOL_H
-#define LIBDEVICE_VOL_H
+#ifndef _LIBC_VOL_H_
+#define _LIBC_VOL_H_
 
 #include <async.h>
Index: uspace/lib/device/src/bd.c
===================================================================
--- uspace/lib/device/src/bd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/bd.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/bd_srv.c
===================================================================
--- uspace/lib/device/src/bd_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/bd_srv.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/device/led_dev.c
===================================================================
--- uspace/lib/device/src/device/led_dev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/device/led_dev.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/devman.c
===================================================================
--- uspace/lib/device/src/devman.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/devman.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -29,5 +29,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/io/chardev.c
===================================================================
--- uspace/lib/device/src/io/chardev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/io/chardev.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/io/chardev_srv.c
===================================================================
--- uspace/lib/device/src/io/chardev_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/io/chardev_srv.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/io/label.c
===================================================================
--- uspace/lib/device/src/io/label.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/io/label.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/irc.c
===================================================================
--- uspace/lib/device/src/irc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/irc.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/pci.c
===================================================================
--- uspace/lib/device/src/pci.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/pci.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/vbd.c
===================================================================
--- uspace/lib/device/src/vbd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/vbd.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/device/src/vol.c
===================================================================
--- uspace/lib/device/src/vol.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/src/vol.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/display/include/ipc/display.h
===================================================================
--- uspace/lib/display/include/ipc/display.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/include/ipc/display.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDISPLAY_IPC_DISPLAY_H
-#define LIBDISPLAY_IPC_DISPLAY_H
+#ifndef _LIBC_IPC_DISPLAY_H_
+#define _LIBC_IPC_DISPLAY_H_
 
 #include <ipc/common.h>
Index: uspace/lib/drv/generic/remote_ieee80211.c
===================================================================
--- uspace/lib/drv/generic/remote_ieee80211.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/generic/remote_ieee80211.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2015 Jan Kolarik
  * All rights reserved.
@@ -85,13 +84,19 @@
 }
 
-// XXX This is wrong. Wifi should not have anything to do with IP links
+static bool mac_matches(uint8_t *mac1, uint8_t *mac2)
+{
+	for (size_t i = 0; i < ETH_ADDR; i++) {
+		if (mac1[i] != mac2[i])
+			return false;
+	}
+
+	return true;
+}
+
 static sysarg_t get_link_id(uint8_t *mac)
 {
 	sysarg_t *link_list;
 	inet_link_info_t link_info;
-	eth_addr_t eth_addr;
 	size_t count;
-
-	eth_addr_decode(mac, &eth_addr);
 
 	errno_t rc = inetcfg_get_link_list(&link_list, &count);
@@ -104,5 +109,5 @@
 			return -1;
 
-		if (eth_addr_compare(&eth_addr, &link_info.mac_addr) == 0)
+		if (mac_matches(mac, link_info.mac_addr))
 			return link_list[i];
 	}
@@ -165,6 +170,4 @@
 		return rc;
 
-	// XXX This is wrong. Wifi should not initiate DHCP
-
 	/* Send DHCP discover. */
 	nic_address_t wifi_mac;
@@ -204,7 +207,4 @@
 	if (rc != EOK)
 		return rc;
-
-	eth_addr_t eth_addr;
-	eth_addr_decode(wifi_mac.address, &eth_addr);
 
 	inet_link_info_t link_info;
@@ -215,6 +215,4 @@
 	size_t count;
 
-	/// XXX This is wrong. Wifi should do nothing with DHCP
-
 	/* Remove previous DHCP address. */
 	rc = inetcfg_get_addr_list(&addr_list, &count);
@@ -231,5 +229,5 @@
 			return rc;
 
-		if (eth_addr_compare(&eth_addr, &link_info.mac_addr) == 0) {
+		if (mac_matches(wifi_mac.address, link_info.mac_addr)) {
 			if (str_test_prefix(addr_info.name, "dhcp")) {
 				rc = inetcfg_addr_delete(addr_list[i]);
Index: uspace/lib/drv/include/battery_iface.h
===================================================================
--- uspace/lib/drv/include/battery_iface.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/include/battery_iface.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdrv
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/drv/include/ieee80211_iface.h
===================================================================
--- uspace/lib/drv/include/ieee80211_iface.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/include/ieee80211_iface.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdrv
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/drv/include/nic_iface.h
===================================================================
--- uspace/lib/drv/include/nic_iface.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/include/nic_iface.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdrv
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/gfx/include/gfx/color.h
===================================================================
--- uspace/lib/gfx/include/gfx/color.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/include/gfx/color.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2019 Jiri Svoboda
  * All rights reserved.
  *
@@ -43,9 +43,7 @@
 extern errno_t gfx_color_new_rgb_i16(uint16_t, uint16_t,
     uint16_t, gfx_color_t **);
-extern errno_t gfx_color_new_ega(uint8_t, gfx_color_t **);
 extern void gfx_color_delete(gfx_color_t *);
 extern void gfx_color_get_rgb_i16(gfx_color_t *, uint16_t *, uint16_t *,
     uint16_t *);
-extern void gfx_color_get_ega(gfx_color_t *, uint8_t *);
 
 #endif
Index: uspace/lib/gfx/include/types/gfx/ops/context.h
===================================================================
--- uspace/lib/gfx/include/types/gfx/ops/context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/include/types/gfx/ops/context.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -44,5 +44,4 @@
 #include <types/gfx/coord.h>
 #include <types/gfx/context.h>
-#include <stdbool.h>
 
 /** Graphics context ops */
@@ -65,10 +64,4 @@
 	/** Get bitmap allocation info */
 	errno_t (*bitmap_get_alloc)(void *, gfx_bitmap_alloc_t *);
-	/** Get hardware cursor position */
-	errno_t (*cursor_get_pos)(void *, gfx_coord2_t *);
-	/** Set hardware cursor position */
-	errno_t (*cursor_set_pos)(void *, gfx_coord2_t *);
-	/** Set hardware cursor visibility */
-	errno_t (*cursor_set_visible)(void *, bool);
 } gfx_context_ops_t;
 
Index: uspace/lib/gfx/meson.build
===================================================================
--- uspace/lib/gfx/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2019 Jiri Svoboda
 # All rights reserved.
 #
@@ -32,5 +32,4 @@
 	'src/coord.c',
 	'src/context.c',
-	'src/cursor.c',
 	'src/render.c'
 )
@@ -40,5 +39,4 @@
 	'test/color.c',
 	'test/coord.c',
-	'test/cursor.c',
 	'test/main.c',
 	'test/render.c',
Index: uspace/lib/gfx/private/color.h
===================================================================
--- uspace/lib/gfx/private/color.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/private/color.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2019 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,5 +48,4 @@
 	uint16_t g;
 	uint16_t b;
-	uint8_t attr;
 };
 
Index: uspace/lib/gfx/src/color.c
===================================================================
--- uspace/lib/gfx/src/color.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/src/color.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2019 Jiri Svoboda
  * All rights reserved.
  *
@@ -69,26 +69,4 @@
 }
 
-/** Create new EGA color.
- *
- * @param attr EGA attributes
- * @param rcolor Place to store pointer to new color
- *
- * @return EOK on success or an error code, ENOMEM if out of resources,
- *         EIO if the graphic device connection was lost
- */
-errno_t gfx_color_new_ega(uint8_t attr, gfx_color_t **rcolor)
-{
-	gfx_color_t *color;
-
-	color = calloc(1, sizeof(gfx_color_t));
-	if (color == NULL)
-		return ENOMEM;
-
-	color->attr = attr;
-
-	*rcolor = color;
-	return EOK;
-}
-
 /** Delete color.
  *
@@ -115,14 +93,4 @@
 }
 
-/** Convert color to EGA attributes.
- *
- * @param color Color
- * @param attr Place to store EGA attributes
- */
-void gfx_color_get_ega(gfx_color_t *color, uint8_t *attr)
-{
-	*attr = color->attr;
-}
-
 /** @}
  */
Index: uspace/lib/gfx/test/main.c
===================================================================
--- uspace/lib/gfx/test/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/test/main.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,5 +34,4 @@
 PCUT_IMPORT(color);
 PCUT_IMPORT(coord);
-PCUT_IMPORT(cursor);
 PCUT_IMPORT(render);
 
Index: uspace/lib/gfxfont/include/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/text.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/include/gfx/text.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,12 +46,4 @@
 extern errno_t gfx_puttext(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
     const char *);
-extern void gfx_text_start_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *);
-extern size_t gfx_text_find_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *);
-extern void gfx_text_cont(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *, gfx_text_fmt_t *);
-extern void gfx_text_rect(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_rect_t *);
 
 #endif
Index: uspace/lib/gfxfont/include/types/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/text.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/include/types/gfx/text.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -42,9 +42,9 @@
 /** Text horizontal alignment */
 typedef enum {
-	/** Align text left (start at anchor point) */
+	/** Align text left */
 	gfx_halign_left,
-	/** Align text on the center (center around anchor point) */
+	/** Align text on the center */
 	gfx_halign_center,
-	/** Align text right (end just before anchor point) */
+	/** Align text right */
 	gfx_halign_right,
 	/** Justify text on both left and right edge */
@@ -54,9 +54,9 @@
 /** Text vertical alignment */
 typedef enum {
-	/** Align top (starts at anchor point) */
+	/** Align top */
 	gfx_valign_top,
-	/** Align center (centered around anchor point) */
+	/** Align center */
 	gfx_valign_center,
-	/** Align bottom (end just before anchor point) */
+	/** Align bottom */
 	gfx_valign_bottom,
 	/** Align to baseline */
Index: uspace/lib/gfxfont/src/text.c
===================================================================
--- uspace/lib/gfxfont/src/text.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/src/text.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -110,10 +110,8 @@
 	gfx_bitmap_t *bitmap;
 	gfx_bitmap_alloc_t alloc;
-	uint8_t attr;
+	uint16_t r, g, b;
 	pixelmap_t pmap;
 	gfx_coord_t x;
 	pixel_t pixel;
-	char32_t c;
-	size_t off;
 	errno_t rc;
 
@@ -123,5 +121,13 @@
 	 */
 
-	gfx_color_get_ega(color, &attr);
+	gfx_color_get_rgb_i16(color, &r, &g, &b);
+
+	/*
+	 * We are setting the *background* color, the foreground color
+	 * will be set to its complement.
+	 */
+	r = 0xff ^ (r >> 8);
+	g = 0xff ^ (g >> 8);
+	b = 0xff ^ (b >> 8);
 
 	gfx_bitmap_params_init(&params);
@@ -150,11 +156,6 @@
 	pmap.data = alloc.pixels;
 
-	off = 0;
 	for (x = 0; x < params.rect.p1.x; x++) {
-		c = str_decode(str, &off, STR_NO_LIMIT);
-		pixel = PIXEL(attr,
-		    (c >> 16) & 0xff,
-		    (c >> 8) & 0xff,
-		    c & 0xff);
+		pixel = PIXEL(str[x], r, g, b);
 		pixelmap_put_pixel(&pmap, x, 0, pixel);
 	}
@@ -166,5 +167,5 @@
 }
 
-/** Get text starting position.
+/** Render text.
  *
  * @param font Font
@@ -172,13 +173,19 @@
  * @param fmt Text formatting
  * @param str String
- * @param spos Place to store starting position
- */
-void gfx_text_start_pos(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *spos)
+ * @return EOK on success or an error code
+ */
+errno_t gfx_puttext(gfx_font_t *font, gfx_coord2_t *pos,
+    gfx_text_fmt_t *fmt, const char *str)
 {
 	gfx_font_metrics_t fmetrics;
+	gfx_glyph_metrics_t gmetrics;
+	size_t stradv;
+	const char *cp;
+	gfx_glyph_t *glyph;
+	gfx_coord2_t cpos;
 	gfx_coord_t width;
-
-	*spos = *pos;
+	errno_t rc;
+
+	cpos = *pos;
 
 	/* Adjust position for horizontal alignment */
@@ -187,8 +194,8 @@
 		switch (fmt->halign) {
 		case gfx_halign_center:
-			spos->x -= width / 2;
+			cpos.x -= width / 2;
 			break;
 		case gfx_halign_right:
-			spos->x -= width;
+			cpos.x -= width - 1;
 			break;
 		default:
@@ -203,11 +210,11 @@
 		switch (fmt->valign) {
 		case gfx_valign_top:
-			spos->y += fmetrics.ascent;
+			cpos.y += fmetrics.ascent;
 			break;
 		case gfx_valign_center:
-			spos->y += fmetrics.ascent / 2;
+			cpos.y += fmetrics.ascent / 2;
 			break;
 		case gfx_valign_bottom:
-			spos->y -= fmetrics.descent + 1;
+			cpos.y -= fmetrics.descent;
 			break;
 		default:
@@ -215,25 +222,4 @@
 		}
 	}
-}
-
-/** Render text.
- *
- * @param font Font
- * @param pos Anchor position
- * @param fmt Text formatting
- * @param str String
- * @return EOK on success or an error code
- */
-errno_t gfx_puttext(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str)
-{
-	gfx_glyph_metrics_t gmetrics;
-	size_t stradv;
-	const char *cp;
-	gfx_glyph_t *glyph;
-	gfx_coord2_t cpos;
-	errno_t rc;
-
-	gfx_text_start_pos(font, pos, fmt, str, &cpos);
 
 	/* Text mode */
@@ -266,126 +252,4 @@
 }
 
-/** Find character position in string by X coordinate.
- *
- * @param font Font
- * @param pos Anchor position
- * @param fmt Text formatting
- * @param str String
- * @param fpos Position for which we need to find offset
- *
- * @return Byte offset in @a str of character corresponding to position
- *         @a fpos. Note that the position is rounded, that is,
- *         if it is before the center of character A, it will return
- *         offset of A, if it is after the center of A, it will return
- *         offset of the following character.
- */
-size_t gfx_text_find_pos(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *fpos)
-{
-	gfx_glyph_metrics_t gmetrics;
-	size_t stradv;
-	const char *cp;
-	gfx_glyph_t *glyph;
-	gfx_coord2_t cpos;
-	size_t off;
-	size_t strsize;
-	errno_t rc;
-
-	gfx_text_start_pos(font, pos, fmt, str, &cpos);
-
-	/* Text mode */
-	if ((font->finfo->props.flags & gff_text_mode) != 0) {
-		off = 0;
-		strsize = str_size(str);
-		while (off < strsize) {
-			if (fpos->x <= cpos.x)
-				return off;
-			(void) str_decode(str, &off, strsize);
-			cpos.x++;
-		}
-
-		return off;
-	}
-
-	cp = str;
-	off = 0;
-	while (*cp != '\0') {
-		rc = gfx_font_search_glyph(font, cp, &glyph, &stradv);
-		if (rc != EOK) {
-			++cp;
-			continue;
-		}
-
-		gfx_glyph_get_metrics(glyph, &gmetrics);
-
-		if (fpos->x < cpos.x + gmetrics.advance / 2)
-			return off;
-
-		cp += stradv;
-		off += stradv;
-		cpos.x += gmetrics.advance;
-	}
-
-	return off;
-}
-
-/** Get text continuation parameters.
- *
- * Return the anchor position and format needed to continue printing
- * text after the specified string. It is allowed for the sources
- * (@a pos, @a fmt) and destinations (@a cpos, @a cfmt) to point
- * to the same objects, respectively.
- *
- * @param font Font
- * @param pos Anchor position
- * @param fmt Text formatting
- * @param str String
- * @param cpos Place to store anchor position for continuation
- * @param cfmt Place to store format for continuation
- */
-void gfx_text_cont(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *cpos,
-    gfx_text_fmt_t *cfmt)
-{
-	gfx_coord2_t spos;
-	gfx_text_fmt_t tfmt;
-
-	/* Continuation should start where the current string ends */
-	gfx_text_start_pos(font, pos, fmt, str, &spos);
-	cpos->x = spos.x + gfx_text_width(font, str);
-	cpos->y = spos.y;
-
-	/*
-	 * Formatting is the same, except the text should be aligned
-	 * so that it starts at the anchor point.
-	 */
-	tfmt = *fmt;
-	tfmt.halign = gfx_halign_left;
-	tfmt.valign = gfx_valign_baseline;
-
-	*cfmt = tfmt;
-}
-
-/** Get text bounding rectangle.
- *
- * @param font Font
- * @param pos Anchor position
- * @param fmt Text formatting
- * @param str String
- * @param rect Place to store bounding rectangle
- */
-void gfx_text_rect(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_rect_t *rect)
-{
-	gfx_coord2_t spos;
-
-	gfx_text_start_pos(font, pos, fmt, str, &spos);
-
-	rect->p0.x = spos.x;
-	rect->p0.y = spos.y - font->metrics.ascent;
-	rect->p1.x = spos.x + gfx_text_width(font, str);
-	rect->p1.y = spos.y + font->metrics.descent + 1;
-}
-
 /** @}
  */
